import es
import os
import popuplib

###############################################################################################################################
##################################### Start of Options ########################################################################
###############################################################################################################################

# Admins, which can change the Map lists
admins = ['STEAM_0:1:23951652', 'STEAM_0:1:22250488', 'STEAM_0:0:26428466'] 

# Command to open the Menu
cmdopen = "!mchange"

# Change the maplist.txt 1 = yes, 0 = No
maplistshow = 1

# Change the mapcycle.txt 1 = yes, 0 = No
mapcycleshow = 1

# Change the votemaplist.txt 1 = yes, 0 = No
votemaplistshow = 1

# the Maps MUST start with the Prefix you add here, so you can change it in the map list, for every Prefix a new entry
prefix = ['cs_', 'de_', 'pa_', 'ka_', 'he_', 'fy_', 'dm_', 'awp_', 'ba_', 'fun_', 'scout_', 'surf_', 'glass_', 'cl_', 'rats_', 'hc_', 'as_', 'pb_', 'sg_', 'bh_', 'is_', 'hst_', 'dr_', 'tz_', 'mg_', 'jail_', 'td_']

###############################################################################################################################
##################################### End of Options ##########################################################################
###############################################################################################################################




maps = es.getString('eventscripts_gamedir') + '/maps'
maplist = es.getString('eventscripts_gamedir') + '/maplist.txt'
mapcycle = es.getString('eventscripts_gamedir') + '/mapcycle.txt' 
votemaplist = es.getString('eventscripts_gamedir') + '/cfg/mani_admin_plugin/votemaplist.txt'

info = es.AddonInfo()
info.name = "MapListAdder"
info.version = "1.0"
info.author = "Popoklopsi"
info.url = "http://www.hlpr-clan.de/"
info.basename = "maplistadder"
info.description = "Edit easy your Map Lists"

def load():
	v = popuplib.create('menu')
	v.addline('Edit the Map lists')
	v.addline('----------------------------------------------------')
	v.addline('->1. Change the Map Prefixes')
	v.addline('->2. Add an additional Map Prefix')
	v.addline('->3. Delete an additional Map Prefix')
	v.addline('->4. Add a single Map')
	v.addline('->5. Delete a single Map')
	v.addline('-----------------------------------------------------')
	v.addline('->0. Exit')
	v.menuselect = menuchoose
	es.set("%s" % info.basename,info.version)
	es.makepublic("%s" % info.basename)
	es.regsaycmd(cmdopen, 'maplistadder/send', 'send the menu')
	
def unload():
	es.unregsaycmd(cmdopen)
	
def send():
	userid = es.getcmduserid()
	if es.getplayersteamid(userid) in admins:
		popuplib.send('menu', userid)
	else:
		es.tell(userid, '#multi', '#lightgreen You are #green NO ADMIN!')

def menuchoose(userid, choice, popupname):
	if choice == 1:
		m = popuplib.easymenu('mlist',None, mlistchange)
		m.settitle('On which Map Prefix you want to change?')
		m.addoption('all', 'All Maps')
		for x in prefix:
			m.addoption(x, '%s Maps' % x)
		m.send(userid)
	if choice == 2:
		n = popuplib.easymenu('mcycle',None, mlistadd)
		n.settitle('Which Map Prefix you want to add?')
		for x in prefix:
			n.addoption(x, '%s Maps' % x)
		n.send(userid)
	if choice == 3:
		b = popuplib.easymenu('vlist',None, mlistdelete)
		b.settitle('which Map Prefix you want to delete?')
		for x in prefix:
			b.addoption(x, '%s Maps' % x)
		b.send(userid)
	if choice == 4:
		allready = []
		if maplistshow == 1:
			i = open(maplist, 'r')
		elif mapcycleshow == 1:
			i = open(mapcycle, 'r')
		elif votemaplistshow == 1:
			i = open(votemaplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			allready.append(addnow)
		i.close()
		c = popuplib.easymenu('madd',None, madd)
		c.settitle('which Map you want to add?')
		for x in os.listdir(maps):
			if '.bsp' in x:
				if '.ztmp' not in x:
					toadd = x.replace('.bsp', '')
					if toadd not in allready:
						c.addoption(toadd, toadd)
		c.send(userid)
	if choice == 5:
		y = popuplib.easymenu('mdelete',None, mdelete)
		y.settitle('which Map you want to delete')
		if maplistshow == 1:
			i = open(maplist, 'r')
		elif mapcycleshow == 1:
			i = open(mapcycle, 'r')
		elif votemaplistshow == 1:
			i = open(votemaplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			y.addoption(addnow, addnow)
		y.send(userid)
		i.close()
				
def mlistchange(userid, choice, popupname):
	if choice == 'all':
		if maplistshow == 1:
			liste = []
			for x in os.listdir(maps):
				if '.bsp' in x:
					if '.ztmp' not in x:
						adding = x.replace('.bsp', '')
						liste.append(adding)
			p = open(maplist, 'w')
			counter = 0
			for x in liste:
				counter = counter + 1
			counter = counter - 1
			for x in liste:
				if x != liste[counter]:
					p.write(x + '\n')
				else:
					p.write(x)
			p.close()
		if mapcycleshow == 1:
			liste = []
			for x in os.listdir(maps):
				if '.bsp' in x:
					if '.ztmp' not in x:
						adding = x.replace('.bsp', '')
						liste.append(adding)
			p = open(mapcycle, 'w')
			counter = 0
			for x in liste:
				counter = counter + 1
			counter = counter - 1
			for x in liste:
				if x != liste[counter]:
					p.write(x + '\n')
				else:
					p.write(x)
			p.close()
		if votemaplistshow == 1:
			liste = []
			for x in os.listdir(maps):
				if '.bsp' in x:
					if '.ztmp' not in x:
						adding = x.replace('.bsp', '')
						liste.append(adding)
			p = open(votemaplist, 'w')
			counter = 0
			for x in liste:
				counter = counter + 1
			counter = counter - 1
			for x in liste:
				if x != liste[counter]:
					p.write(x + '\n')
				else:
					p.write(x)
			p.close()
	else:
		if maplistshow == 1:
			liste = []
			for x in os.listdir(maps):
				if '.bsp' in x:
					if '.ztmp' not in x:
						if choice in x:
							adding = x.replace('.bsp', '')
							liste.append(adding)
			p = open(maplist, 'w')
			counter = 0
			for x in liste:
				counter = counter + 1
			counter = counter - 1
			for x in liste:
				if x != liste[counter]:
					p.write(x + '\n')
				else:
					p.write(x)
			p.close()
		if mapcycleshow == 1:
			liste = []
			for x in os.listdir(maps):
				if '.bsp' in x:
					if '.ztmp' not in x:
						if choice in x:
							adding = x.replace('.bsp', '')
							liste.append(adding)
			p = open(mapcycle, 'w')
			counter = 0
			for x in liste:
				counter = counter + 1
			counter = counter - 1
			for x in liste:
				if x != liste[counter]:
					p.write(x + '\n')
				else:
					p.write(x)
			p.close()
		if votemaplistshow == 1:
			liste = []
			for x in os.listdir(maps):
				if '.bsp' in x:
					if '.ztmp' not in x:
						if choice in x:
							adding = x.replace('.bsp', '')
							liste.append(adding)
			p = open(votemaplist, 'w')
			counter = 0
			for x in liste:
				counter = counter + 1
			counter = counter - 1
			for x in liste:
				if x != liste[counter]:
					p.write(x + '\n')
				else:
					p.write(x)
			p.close()
	popuplib.send('menu', userid)
	es.tell(userid, '#multi', '#green %s Maps #lightgreen are now in the Map List' % choice)
		
def mlistadd(userid, choice, popupname):
	if maplistshow == 1:
		liste = []
		for x in os.listdir(maps):
			if '.bsp' in x:
				if '.ztmp' not in x:
					if choice in x:
						adding = x.replace('.bsp', '')
						liste.append(adding)
		i = open(maplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		p = open(maplist, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	if mapcycleshow == 1:
		liste = []
		for x in os.listdir(maps):
			if '.bsp' in x:
				if '.ztmp' not in x:
					if choice in x:
						adding = x.replace('.bsp', '')
						liste.append(adding)
		i = open(mapcycle, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		p = open(mapcycle, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	if votemaplistshow == 1:
		liste = []
		for x in os.listdir(maps):
			if '.bsp' in x:
				if '.ztmp' not in x:
					if choice in x:
						adding = x.replace('.bsp', '')
						liste.append(adding)
		i = open(votemaplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		p = open(votemaplist, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	popuplib.send('menu', userid)
	es.tell(userid, '#multi', '#green %s Maps #lightgreen added to the Map list' % choice)
		
def mlistdelete(userid, choice, popupname):
	if maplistshow == 1:
		liste = []
		i = open(maplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		for x in os.listdir(maps):
			if '.bsp' in x:
				if '.ztmp' not in x:
					if choice in x:
						removing = x.replace('.bsp', '')
						liste.remove(removing)
		p = open(maplist, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	if mapcycleshow == 1:
		liste = []
		i = open(mapcycle, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		for x in os.listdir(maps):
			if '.bsp' in x:
				if '.ztmp' not in x:
					if choice in x:
						removing = x.replace('.bsp', '')
						liste.remove(removing)
		p = open(mapcycle, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	if votemaplistshow == 1:
		liste = []
		i = open(votemaplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		for x in os.listdir(maps):
			if '.bsp' in x:
				if '.ztmp' not in x:
					if choice in x:
						removing = x.replace('.bsp', '')
						liste.remove(removing)
		p = open(votemaplist, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	popuplib.send('menu', userid)
	es.tell(userid, '#multi', '#green %s Maps #lightgreen deleted from the Map list' % choice)
		
def madd(userid, choice, popupname):
	if maplistshow == 1:
		liste = []
		i = open(maplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		liste.append(choice)
		p = open(maplist, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	if mapcycleshow == 1:
		liste = []
		i = open(mapcycle, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		liste.append(choice)
		p = open(mapcycle, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	if votemaplistshow == 1:
		liste = []
		i = open(votemaplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		liste.append(choice)
		p = open(votemaplist, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	popuplib.send('menu', userid)
	es.tell(userid, '#multi', '#green %s #lightgreen added to the Map list' % choice)
		
def mdelete(userid, choice, popupname):
	if maplistshow == 1:
		liste = []
		i = open(mapcycle, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		liste.remove(choice)
		p = open(mapcycle, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	if mapcycleshow == 1:
		liste = []
		i = open(maplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		liste.remove(choice)
		p = open(maplist, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	if votemaplistshow == 1:
		liste = []
		i = open(votemaplist, 'r')
		for x in i:
			addnow = x.replace('\n', '')
			liste.append(addnow)
		i.close()
		liste.remove(choice)
		p = open(votemaplist, 'w')
		counter = 0
		for x in liste:
			counter = counter + 1
		counter = counter - 1
		for x in liste:
			if x != liste[counter]:
				p.write(x + '\n')
			else:
				p.write(x)
		p.close()
	popuplib.send('menu', userid)
	es.tell(userid, '#multi', '#green %s #lightgreen deleted from the Map list' % choice)